; Altirra Acid800 test suite
; Copyright (C) 2010 Avery Lee, All Rights Reserved.
;
; Permission is hereby granted, free of charge, to any person obtaining a copy
; of this software and associated documentation files (the "Software"), to deal
; in the Software without restriction, including without limitation the rights
; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the Software is
; furnished to do so, subject to the following conditions:
;
; The above copyright notice and this permission notice shall be included in
; all copies or substantial portions of the Software.
;
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
; SOFTWARE. 

		_SAP_HEADER "GTIA: P/M retriggering"

		opt		h+o+

		icl		'library.s'

		org		$2000

main:
		ldy		#>testname
		lda		#<testname
		jsr		_testInit
		
		jsr		_screenOff
		jsr		_interruptsOff
		
		mva		#$00 gractl
		mva		#$ff grafp0
		mva		#$ff grafp1
		mva		#$ff grafp2
		mva		#$40 hposp0
		mva		#$40 hposp1
		mva		#$b8 hposp2
		mva		#$00 sizep0
		mva		#$00 sizep1
		mva		#$00 sizep2
		
		;try basic retriggering
		lda		#8
		jsr		_waitVCount
		sta		wsync
		mva		#$40 hposp0
		lda		#$b8
		sta		wsync
		sta		hitclr			;*, 104, 105, 106
		sta		d0				;107, 108, 109
		pha:pla					;110-113, 0-2
		pha:pla					;3-9
		pha:pla					;10-16
		pha:pla					;17-23
		pha:pla					;24, 25*, 26, 27, 28, 29*, 30, 31, 32
		pha:pla					;33*, 34, 35, 36, 37*, 38, 39, 40, 41*
		pha:pla					;42, 43, 44, 45*, 46, 47, 48, 48*, 50
		pha:pla					;51, 52, 53*, 54, 55, 56, 57*, 58, 59
		sta		hposp0			;60, 61, 62, 63
		inc		wsync
		lda		p0pl
		and		#$06
		_ASSERTA $06, c"Player did not retrigger properly."
		
		;try retriggering one cycle too early
		lda		#8
		jsr		_waitVCount
		sta		wsync
		mva		#$40 hposp0
		lda		#$b8
		sta		wsync
		sta		hitclr			;*, 104, 105, 106
		sta		d0				;107, 108, 109
		pha:pla					;110-113, 0-3
		pha:pla					;3-9
		pha:pla					;10-16
		sta		d0				;17-19
		sta		d0				;20-22
		sta		hposp0			;23, 24*, 25, 26, **27**
		inc		wsync
		lda		p0pl
		and		#$06
		_ASSERTA $04, c"Player retrigger timing test #1 failed: $%x."

		;try retriggering as early as possible
		lda		#8
		jsr		_waitVCount
		sta		wsync
		mva		#$40 hposp0
		lda		#$b8
		sta		wsync
		sta		hitclr			;*, 104, 105, 106
		sta		d0				;107, 108, 109
		pha:pla					;110-113, 0-3
		pha:pla					;3-9
		pha:pla					;10-16
		pha:pla					;17-23
		sta		hposp0			;24*, 25, 26, 27, 28*, **29**
		inc		wsync
		lda		p0pl
		and		#$06
		_ASSERTA $06, c"Player retrigger timing test #2 failed: $%x."
		
		;try retriggering as late as possible
		lda		#8
		jsr		_waitVCount
		sta		wsync
		mva		#$40 hposp0
		lda		#$b8
		sta		wsync
		sta		hitclr			;*, 104, 105, 106
		sta		d0				;107, 108, 109
		pha:pla					;110-113, 0-2
		pha:pla					;3-9
		pha:pla					;10-16
		pha:pla					;17-23
		pha:pla					;24*, 25, 26, 27, 28*, 29, 30, 31, 32*, 33
		pha:pla					;34, 35, 36*, 37, 38, 39, 40*, 41, 42
		pha:pla					;43, 44*, 45, 46, 47, 48*, 49, 50, 51
		pha:pla					;52*, 53, 54, 55, 56*, 57, 58, 59, 60
		pha:pla					;61-67
		pha:pla					;68-74
		pha:pla					;75-81
		sta		d0				;82-84
		sta		hposp0			;85, 86, 87, **88**
		inc		wsync
		lda		p0pl
		and		#$06
		_ASSERTA $06, c"Player retrigger timing test #3 failed: $%x."
		
		;try retriggering one cycle too late
		lda		#8
		jsr		_waitVCount
		sta		wsync
		mva		#$40 hposp0
		lda		#$b8
		sta		wsync
		sta		hitclr			;*, 104, 105, 106
		sta		d0				;107, 108, 109
		pha:pla					;110-113, 0-2
		pha:pla					;3-9
		pha:pla					;10-16
		pha:pla					;17-23
		pha:pla					;24*, 25, 26, 27, 28*, 29, 30, 31, 32*, 33
		pha:pla					;34, 35, 36*, 37, 38, 39, 40*, 41, 42
		pha:pla					;43, 44*, 45, 46, 47, 48*, 49, 50, 51
		pha:pla					;52*, 53, 54, 55, 56*, 57, 58, 59, 60
		pha:pla					;61-67
		pha:pla					;68-74
		pha:pla					;75-81
		sta		$0100			;82-85
		sta		hposp0			;86, 87, 88, **89**
		inc		wsync
		lda		p0pl
		and		#$06
		_ASSERTA $02, c"Player retrigger timing test #4 failed: $%x."
		
		jmp		_testPassed
		
testname:
		dta		c"GTIA: P/M retriggering",0

		run		$2000
		end
